install 4.1 KB

123456789101112131415161718192021222324252627282930313233343536373839404142434445464748495051525354555657585960616263646566676869707172737475767778798081828384858687888990919293949596979899100101102103104105106107108109110111112113114115116117118119120121122123124125126127128129130131132133134135136137138139140141142143144145146147148149150151152153154
  1. #!/bin/bash
  2. #################################################################
  3. # auto-mediawiki #
  4. # Instala un servidor LAMP (Linux+Apache+MySQL+PHP) e instala #
  5. # MediaWiki y lo configura. #
  6. # #
  7. # Guzman Castanedo Villalba (guzman@castanedo.es) Junio 2018 #
  8. # GPLv3 (https://www.gnu.org/licenses/gpl.html) #
  9. #################################################################
  10. OSInfo() {
  11. #printf "Detectando SO..."
  12. debianOS=false
  13. rhelOS=false
  14. OS=$(uname -s)
  15. if [ $OS = "Linux" ]; then
  16. OS="GNU/Linux"
  17. if [ -f /etc/os-release ]; then
  18. DIST=$(grep ^NAME= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  19. REV=$(grep ^VERSION= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  20. ID_LIKE=$(grep ^ID_LIKE= /etc/os-release | cut -d = -f 2 | cut -d '"' -f 2)
  21. for i in $ID_LIKE; do
  22. printf "$i\n"
  23. case $i in
  24. debian|ubuntu)
  25. debianOS=true
  26. break
  27. ;;
  28. rhel|fedora)
  29. rhelOS=true
  30. break
  31. ;;
  32. *)
  33. debianOS=false
  34. rhelOS=false
  35. ;;
  36. esac
  37. done
  38. elif [ -f /etc/debian-version ]; then
  39. # Familia Debian (Debian, Ubuntu, Linux Mint, ...)
  40. DIST="Debian"
  41. REV=""
  42. debianOS=true
  43. elif [ -f /etc/redhat-release ]; then
  44. # Familia Red-Hat (RHEL, Fedora, CentOS, ...)
  45. DIST="Red-Hat"
  46. REV=""
  47. rhelOS=true
  48. else
  49. # Other Linux (No Soportado)
  50. DIST=""
  51. REV=""
  52. fi
  53. else
  54. #UNIX, OS X, ... (No Soportado)
  55. DIST=$OS
  56. REV=""
  57. fi
  58. #printf " $DIST $REV\n"
  59. HDInfo=$(df -h | head -1)"\n"$(df -h | grep ^/dev/sd)
  60. }
  61. comprobarRoot() {
  62. if [ $(id -u) -ne 0 ]; then
  63. printf "ERROR:\tEs necesario ser root ('sudo $0').\n"
  64. exit 1
  65. fi
  66. }
  67. comprobarDependencias() {
  68. if [ ! -x $(which whiptail) ];then
  69. printf "ERROR:\twhiptail no disponible.\n"
  70. exit 1
  71. fi
  72. if [ $debianOS = true ];then
  73. which apt-get > /dev/null 2>&1
  74. if [ $? -ne 0 ]; then
  75. printf "ERROR:\t'apt-get' no está disponible.\n"
  76. exit 1
  77. fi
  78. fi
  79. if [ $rhelOS = true ]; then
  80. which yum > /dev/null 2>&1
  81. if [ $? -ne 0 ]; then
  82. printf "ERROR:\t'yum' no está disponible.\n"
  83. exit 1
  84. fi
  85. fi
  86. }
  87. mostrarBienvenida() {
  88. if [ $debianOS = false ] && [ $rhelOS = false ]; then
  89. whiptail --title "ERROR OS NO SOPORTADO" --msgbox "Este script automatiza la creación de una web MediaWiki SOLO para distribuciones Linux de la familia Debian (Ubuntu, Linux Mint, ...) y de la familia Red-Hat (CentOS, Fedora, ...).\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --ok-button "Salir" 20 70
  90. exit 1
  91. fi
  92. whiptail --title "Instalación MediaWiki" --yesno "Este script automatiza completamente la instalación de una wiki.\nPara ello instala un servidor LAMP, el software MediaWiki y lo configura todo.\n\nInformación del sistema:\nOS: $OS $DIST $REV\n$HDInfo" --yes-button "Continuar" --no-button "Salir" 20 70
  93. if [ $? -ne 0 ]; then
  94. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  95. exit 2
  96. fi
  97. }
  98. # Comprobamos
  99. comprobarRoot
  100. OSInfo
  101. comprobarDependencias
  102. # Bienvenida
  103. mostrarBienvenida
  104. # Selección de componentes
  105. componentes=$(whiptail --title "Instalación" --checklist "<ESPACIO>: seleccionar <TAB>: cambiar <FLECHAS>: moverse\n\nEscoge los componentes que quieres instalar:" 20 70 5 \
  106. "WebServer" "Instalar servidor web http/https" ON \
  107. "Database" "Instalar una base de datos SQL" ON \
  108. "PHP" "Instala PHP7" ON \
  109. "SSL/TLS" "Instala certificados para activar HTTPS" ON \
  110. "MediaWiki" "Instala la última versión de MediaWiki" ON \
  111. --ok-button "Continuar" --cancel-button "Salir" 3>&1 1>&2 2>&3)
  112. if [ $? -ne 0 ]; then
  113. printf "ERROR:\tInstalación interrumpida por el usuario.\n"
  114. exit 2
  115. fi
  116. #printf "$componentes\n"
  117. for i in $componentes; do
  118. case $i in
  119. \"WebServer\")
  120. printf "Instalación WebServer\n"
  121. ;;
  122. \"Database\")
  123. printf "Instalación Database\n"
  124. ;;
  125. \"PHP\")
  126. printf "Instalación PHP\n"
  127. ;;
  128. \"SSL/TLS\")
  129. printf "Instalación SSL/TLS\n"
  130. ;;
  131. \"MediaWiki\")
  132. printf "Instalación MediaWiki\n"
  133. ;;
  134. *)
  135. printf "ERROR:\tError interno (selección de componentes).\n"
  136. exit 1
  137. ;;
  138. esac
  139. done
  140. # Autodestrucción
  141. {
  142. for i in $(seq 0 5 100); do
  143. sleep 0.1
  144. echo $i
  145. done
  146. } | whiptail --gauge "Autodestrucción..." 7 70 0